
#include <avr/io.h>
#include <avr/pgmspace.h> 
#include "user_defs.h"

// ֐vg^Cv
void beep_init(void);
void beep(void);
void beep_set(uint8_t number);
void beep_test_data_set(void);

// ϐ
static uint8_t beep_type;						// r[v
static uint8_t beep_index;						// r[vĐf[^ʒu


// r[ve[u
// 0[hځFPWM^C}l(0:Gh}[N 255܂Őݒ)
// 1[hځF(65535܂Őݒ)
uint16_t beep_test[17] = {	// ꂾRAM̃f[^ƂĒ`
	255,1000,
	BEEP_END
};

const uint16_t PROGMEM beep_stop[]={
	BEEP_END
};

const uint16_t PROGMEM beep_type1[]={
	5,1000,
	BEEP_END
};

const uint16_t PROGMEM beep_type2[]={
	11,1000,
	BEEP_END
};

const uint16_t PROGMEM beep_type3[]={
	11,500,
	5,500,
	BEEP_END
};

const uint16_t PROGMEM beep_type4[]={
	5,500,
	11,500,
	BEEP_END
};

const uint16_t PROGMEM beep_type5[]={
	11,1000,
	9,1000,
	5,1000,
	BEEP_END
};

const uint16_t PROGMEM beep_type6[]={
	5,1000,
	9,1000,
	11,1000,
	BEEP_END
};

const uint16_t PROGMEM beep_type7[]={
	50,500,
	0,700,
	50,500,
	BEEP_END
};

const uint16_t PROGMEM beep_type8[] = {
	11,2000,
	BEEP_END
};

const uint16_t PROGMEM beep_type9[] = {
	11,10000,
	BEEP_END
};

const uint16_t PROGMEM *beep_table[]={
	&beep_stop[0],
	&beep_type1[0],
	&beep_type2[0],
	&beep_type3[0],
	&beep_type4[0],
	&beep_type5[0],
	&beep_type6[0],
	&beep_type7[0],
	&beep_type8[0],
	&beep_type9[0],
};

/*******************************************************
	BEEPRAMf[^(pI)
********************************************************/
void beep_test_data_set(void){
#if 1
	uint8_t i;

	for(i=0;i<((ELEMENT(beep_test)/2)-1);i++){
		beep_test[i*2+0] = (uint8_t)(255-i*2);
		beep_test[i*2+1] = 100;
	}
	beep_test[i*2+0] = BEEP_LOOP;
#endif
}

/*******************************************************
	BEEP
********************************************************/
void beep_init(void){
	TCCR2B = 0;
	beep_set(0);
}

/*******************************************************
	BEEPĐJn
********************************************************/
void beep_set(uint8_t type){
	beep_type = type;
	beep_index = 0;
}

/*******************************************************
	BEEPĐ
********************************************************/
void beep(void){
	const uint16_t *adr;

	if(beep_type == 0xff){
		// beepʂ0xffȂRAMQƂ
		adr = &beep_test[0];
		if((TIFR1 & _BV(TOV1)) != 0){
			if(*(adr + beep_index * 2 + 0) == BEEP_END){
				TCCR2B = 0;
			}else if(*(adr + beep_index * 2 + 0) == BEEP_LOOP){
				beep_index = 0;
			}else if(*(adr + beep_index * 2 + 0) == 0){
				TCCR2B = 0;
				TCNT1 = 0xffff - (*(adr + beep_index * 2 + 1));
				TIFR1 |= _BV(TOV1);
				beep_index++;
			}else{
				OCR2A =	*(adr + beep_index * 2 + 0);
				OCR2B =	*(adr + beep_index * 2 + 0) / 2;
				TCCR2B = _BV(WGM22)| _BV(CS22) | _BV(CS21) | _BV(CS20);
				TCNT1 = 0xffff - (*(adr + beep_index * 2 + 1));
				TIFR1 |= _BV(TOV1);
				beep_index++;
			}
		}
	}else if(beep_type < ELEMENT(beep_table)){
		// beepʂe[u͈͓łROMQƂ
		adr = (const uint16_t *)pgm_read_word(&beep_table[beep_type]);
		if((TIFR1 & _BV(TOV1)) != 0){
			if(pgm_read_word(adr + beep_index * 2 + 0) == BEEP_END){
				TCCR2B = 0;
			}else if(pgm_read_word(adr + beep_index * 2 + 0) == BEEP_LOOP){
				beep_index = 0;
			}else if(pgm_read_word(adr + beep_index * 2 + 0) == 0){
				TCCR2B = 0;
				TCNT1 = 0xffff - pgm_read_word(adr + beep_index * 2 + 1);
				TIFR1 |= _BV(TOV1);
				beep_index++;
			}else{
				OCR2A =	pgm_read_word(adr + beep_index * 2 + 0);
				OCR2B =	pgm_read_word(adr + beep_index * 2 + 0) / 2;
				TCCR2B = _BV(WGM22) | _BV(CS22) | _BV(CS21) | _BV(CS20);
				TCNT1 = 0xffff - pgm_read_word(adr + beep_index * 2 + 1);
				TIFR1 |= _BV(TOV1);
				beep_index++;
			}
		}
	}else{
		// sȂ̂beepZbg
		beep_init();
	}
}

