
// 낢`

//#define SERIAL_MONITOR_DEBUG	// RS-232Cj^fobO

#define true (0==0)
#define false (0==1)

#define ELEMENT(a) (sizeof(a)/sizeof(a[0]))

#define RS232C(speed) ((12000000ul/(16u*speed))-1u)
#define RS232C2X(speed) ((12000000ul/(8u*speed))-1u)

enum logic {
	H = 1,
    L = 0,
};

enum EEPROM_access_type {
	EEPROM_WRITE = 1,
	EEPROM_READ = 0,
};

enum KeyBufferIndex {
	now = 0,
	trigger = 1,
	before_1st = 2,
	before_2nd = 3,
};

enum progress_index {
	target = 0,
	mec = 1,
	bak = 2,
};

enum progress_flag {
	progress_stop = _BV(0),
	progress_play = _BV(1),
	progress_record = _BV(2),
	progress_dump = _BV(3),
	progress_load = _BV(4),
};

enum EEPROM_access_size {
	EEPROM_write_page_size = 128,	// EEPROMݎ̍őoCg
	EEPROM_read_page_size = 128,	// EEPROMǂݍݎ̍őoCg
};

struct tag_keymem {
	uint8_t Timer;
	uint8_t Key1;
	uint8_t Key2;
};

enum character_code {
	STX = 0x02,
	ETX = 0x03,
	ACK = 0x06,
	BEL = 0x07,
	LF = 0x0a,
	CR = 0x0d,
};

enum beep_control {
	BEEP_LOOP = 0xfffe,
	BEEP_END = 0xffff
};

enum beep_type {
	BEEP_STOP = 0,
	BEEP_HIGH = 1,
	BEEP_LOW = 2,
	BEEP_PARAM_UP = 3,
	BEEP_PARAM_DOWN = 4,
	BEEP_COMMAND_START = 5,
	BEEP_COMMAND_END = 6,
	BEEP_COMMAND_NG = 7,
	BEEP_COMMAND_STOP = 8,
	BEEP_COMMAND_ABORT = 9,
	BEEP_TEST = 0xff,
};

struct RECORD_MANAGE_INFORMATION {
	uint8_t flag;
	uint32_t rec_size;
	uint8_t key_header[2];
	uint8_t bad_block[64];
	uint8_t dummy[128-1-4-2-64-2];
	uint16_t sum;
};

enum PS_comminucation_error_flag {
	SYNC_ERROR = _BV(0),
	PSPAD_ERROR = _BV(1)
};

enum RECORD_MANAGE_FLAG {
	CONTINUE_BIT = _BV(0),
};

// LED
#define LEDB_ON() PORTG |= _BV(PORTG4)
#define LEDB_OFF() PORTG &= ~_BV(PORTG4)
#define LEDR_ON() PORTG |= _BV(PORTG3)
#define LEDR_OFF() PORTG &= ~_BV(PORTG3)

// SW
#define SW_PORT (PINL & (_BV(PINL2) | _BV(PINL1) | _BV(PINL0))

// SPI[hpM
#define PSBASE_SEL (PORTB & _BV(PORTB1))
#define PSBASE_SCL (PORTB & _BV(PORTB2))
#define PSBASE_SDO (PORTB & _BV(PORTB3))
#define PSBASE_SDI_H PORTB |= _BV(PORTB4)
#define PSBASE_SDI_L PORTB |= _BV(PORTB4)

// OLED SPI[hpM
#define OLED_SCL_L() PORTL &= ~_BV(PORTL7)
#define OLED_SCL_H() PORTL |= _BV(PORTL7)
#define OLED_SDO_L() PORTL &= ~_BV(PORTL6)
#define OLED_SDO_H() PORTL |= _BV(PORTL6)
#define OLED_CS_L() PORTL &= ~_BV(PORTL5)
#define OLED_CS_H() PORTL |= _BV(PORTL5)
#define OLED_SDI (0u)
